## cpputest 3.7.2

=== CMakeLists.txt ===
project(CppUTest)

set(CppUTest_version_major 3)
set(CppUTest_version_minor 7.2)

# 2.6.3 is needed for ctest support
cmake_minimum_required(VERSION 2.6.3)

option(STD_C "Use the standard C library" ON)
option(STD_CPP "Use the standard C++ library" ON)
option(CPPUTEST_FLAGS "Use the CFLAGS/CXXFLAGS/LDFLAGS set by CppUTest" ON)
option(MEMORY_LEAK_DETECTION "Enable memory leak detection" ON)
option(EXTENSIONS "Use the CppUTest extenstion library" ON)
option(MAP_FILE "Enable the creation of a map file" OFF)
option(COVERAGE "Enable running with coverage" OFF)
option(C++11 "Compile with C++11 support" OFF)

option(TESTS "Compile and make tests for the code?" ON)
option(TESTS_DETAILED "Run each test separately instead of grouped?" OFF)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "What kind of build this is" FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# Pkg-config file
include(FindPkgConfig)
set(CppUTest_PKGCONFIG_FILE cpputest.pc)

set(CppUTestRootDirectory ${PROJECT_SOURCE_DIR})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CppUTestRootDirectory}/cmake/Modules)

include("${CppUTestRootDirectory}/cmake/Modules/CppUTestConfigurationOptions.cmake")
include(CTest)

configure_file (
    "${PROJECT_SOURCE_DIR}/config.h.cmake"
    "${PROJECT_BINARY_DIR}/config.h"
    )
include_directories(${PROJECT_BINARY_DIR})
add_definitions(-DHAVE_CONFIG_H)

include_directories(${CppUTestRootDirectory}/include)
add_subdirectory(src/CppUTest)

if (EXTENSIONS)
    add_subdirectory(src/CppUTestExt)
endif (EXTENSIONS)

if (TESTS)
    add_subdirectory(tests)
endif (TESTS)

# Pkg-config file.
set (prefix "${CMAKE_INSTALL_PREFIX}")
set (exec_prefix "${CMAKE_INSTALL_PREFIX}")
set (libdir "${LIB_INSTALL_DIR}")
set (includedir "${INCLUDE_INSTALL_DIR}")
set (PACKAGE_VERSION "${CppUTest_version_major}.${CppUTest_version_minor}")

configure_file (cpputest.pc.in
    ${CMAKE_CURRENT_SOURCE_DIR}/${CppUTest_PKGCONFIG_FILE} @ONLY)

install(FILES  ${CMAKE_CURRENT_SOURCE_DIR}/${CppUTest_PKGCONFIG_FILE}
    DESTINATION ${LIB_INSTALL_DIR}/pkgconfig
    )

message("
-------------------------------------------------------
CppUTest Version ${CppUTest_version_major}.${CppUTest_version_minor}

Current compiler options:
    CC:                                 ${CMAKE_C_COMPILER}
    CXX:                                ${CMAKE_CXX_COMPILER}
    CppUTest CFLAGS:                    ${CPPUTEST_C_FLAGS}
    CppUTest CXXFLAGS:                  ${CPPUTEST_CXX_FLAGS}
    CppUTest LDFLAGS:                   ${CPPUTEST_LD_FLAGS}

Features configure in CppUTest:
    Memory Leak Detection:              ${MEMORY_LEAK_DETECTION}
    Compiling Extensions:               ${EXTENSIONS}
    Use CppUTest flags:                 ${CPPUTEST_FLAGS}

    Using Standard C library:           ${STD_C}
    Using Standard C++ library:         ${STD_CPP}
    Using C++11 library:                ${C++11}

    Generating map file:                ${MAP_FILE}
    Compiling with coverage:            ${COVERAGE}

-------------------------------------------------------
")

=== examples/Makefile ===
#---------
#
# CppUTest Examples Makefile
#
#----------

#Set this to @ to keep the makefile quiet
ifndef SILENCE
	SILENCE = @
endif

#--- Inputs ----#
COMPONENT_NAME = CppUTestExamples
CPPUTEST_HOME = ..

CPPUTEST_USE_EXTENSIONS = Y
CPP_PLATFORM = Gcc

# This line is overriding the default new macros.  This is helpful
# when using std library includes like <list> and other containers
# so that memory leak detection does not conflict with stl.
CPPUTEST_MEMLEAK_DETECTOR_NEW_MACRO_FILE = -include ApplicationLib/ExamplesNewOverrides.h
SRC_DIRS = \
	ApplicationLib

TEST_SRC_DIRS = \
	AllTests

INCLUDE_DIRS =\
  .\
  ApplicationLib\
  $(CPPUTEST_HOME)/include\

include $(CPPUTEST_HOME)/build/MakefileWorker.mk

=== tests/CMakeLists.txt ===
enable_testing()

set(CppUTestTests_src
    AllTests.cpp
    SetPluginTest.cpp
    CheatSheetTest.cpp
    SimpleStringTest.cpp
    CommandLineArgumentsTest.cpp
    TestFailureTest.cpp
    TestFailureNaNTest.cpp
    CommandLineTestRunnerTest.cpp
    TestFilterTest.cpp
    TestHarness_cTest.cpp
    JUnitOutputTest.cpp
    TestHarness_cTestCFile.c
    MemoryLeakDetectorTest.cpp
    TestInstallerTest.cpp
    AllocLetTestFree.c
    MemoryLeakOperatorOverloadsTest.cpp
    TestMemoryAllocatorTest.cpp
    MemoryLeakWarningTest.cpp
    TestOutputTest.cpp
    AllocLetTestFreeTest.cpp
    TestRegistryTest.cpp
    AllocationInCFile.c
    PluginTest.cpp
    TestResultTest.cpp
    PreprocessorTest.cpp
    TestUTestMacro.cpp
    AllocationInCppFile.cpp
    UtestTest.cpp
    SimpleMutexTest.cpp
    UtestPlatformTest.cpp
)

if (MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4723")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4723")
endif (MSVC)

if (MINGW)
    find_package (Threads REQUIRED)
    set(THREAD_LIB "pthread")
endif (MINGW)

add_executable(CppUTestTests ${CppUTestTests_src})
target_link_libraries(CppUTestTests CppUTest ${THREAD_LIB})

if (TESTS)
    if (TESTS_DETAILED)
        # get all test groups and names
        execute_process(COMMAND tests/CppUTestTests -ln OUTPUT_VARIABLE CppUTestTests_GroupsAndNames)
        # convert space-separated string into a list
        separate_arguments(CppUTestTests_GroupsAndNames)
        # create separate CTest test for each CppUTestTests test
        set(lastgroup "")
        foreach(testfullname ${CppUTestTests_GroupsAndNames})
            string(REGEX MATCH "^([^/.]+)" groupname ${testfullname})
            string(REGEX MATCH "([^/.]+)$" testname ${testfullname})
            if (NOT ("${groupname}" STREQUAL "${lastgroup}"))
                message("TestGroup1: ${groupname}:")
                set(lastgroup "${groupname}")
            endif (NOT ("${groupname}" STREQUAL "${lastgroup}"))
            message("... ${testname}")
            add_test(NAME CppUTest.${testfullname} COMMAND ${EXECUTABLE_OUTPUT_PATH}/CppUTestTests -sg ${groupname} -sn ${testname} -c)
        endforeach()
    else (TESTS_DETAILED)
        # get all test groups
        execute_process(COMMAND tests/CppUTestTests -lg OUTPUT_VARIABLE CppUTestTests_Groups)
        # create separate test for each group
        separate_arguments(CppUTestTests_Groups)
        foreach(group ${CppUTestTests_Groups})
            message("TestGroup1: ${group}")
            add_test(NAME CppUTest.${group} COMMAND ${EXECUTABLE_OUTPUT_PATH}/CppUTestTests -sg ${group} -c)
        endforeach()
    endif (TESTS_DETAILED)

    add_subdirectory(CppUTestExt)
endif (TESTS)

=== platforms/armcc/Makefile ===
# We don't need to clean up when we're making these targets
NODEPS  := clean debug

# CPU architecture. Passing to armcc.exe. For list: armcc --cpu list
ifndef CPU
	CPU = ARM7TDMI
endif

# ARM/THUMB mode. Passing to armcc.exe. May be 'thumb' or 'arm'
ifndef CPU_MODE
	CPU_MODE = thumb
endif

# Path to cygwin binary
CYGWIN_DIR :=C:/CYGWIN/bin

# Path to ARMCC of Keil MDK-ARM, with libraries, includes and executables
KEIL_DIR   :=D:/Keil/ARM/ARMCC

MKDIR      :=$(CYGWIN_DIR)/mkdir
RM         :=$(CYGWIN_DIR)/rm
CC         :=@$(KEIL_DIR)/bin/armcc.exe
AR         :=@$(KEIL_DIR)/bin/armar.exe


# source CppUTest files
CPPUTEST_HOME := ../..
COMPONENT_NAME := CppUTest

INCLUDE_DIRS :=\
  $(CPPUTEST_HOME)/include \
  $(CPPUTEST_HOME)/include/Platforms/armcc \

# armcc system include path
SYS_INCLUDE_DIRS:=$(KEIL_DIR)/include 

SRC_DIRS :=\
  $(CPPUTEST_HOME)/src/$(COMPONENT_NAME)\
  $(CPPUTEST_HOME)/src/Platforms/armcc\

TARGET_PLATFORM :=armcc_$(CPU)_$(CPU_MODE)
CPPUTEST_USE_MEM_LEAK_DETECTION := N
CPPUTEST_USE_STD_CPP_LIB := N
CPPUTEST_USE_VPATH := Y
CPPUTEST_USE_STD_C_LIB := Y
CPPUTEST_ENABLE_DEBUG := Y


# Default dir for temporary files (d, o)
# Default dir for the outout library
CPPUTEST_OBJS_DIR = objs
CPPUTEST_LIB_DIR = $(CPPUTEST_HOME)/lib/$(TARGET_PLATFORM)

TARGET_LIB = \
    $(CPPUTEST_LIB_DIR)/lib$(COMPONENT_NAME).a


#Helper Functions
get_src_from_dir  = $(wildcard $1/*.cpp) $(wildcard $1/*.cc) $(wildcard $1/*.c)
get_dirs_from_dirspec  = $(wildcard $1)
get_src_from_dir_list = $(foreach dir, $1, $(call get_src_from_dir,$(dir)))
__src_to = $(subst .c,$1, $(subst .cc,$1, $(subst .cpp,$1,$(if $(CPPUTEST_USE_VPATH),$(notdir $2),$2))))
src_to = $(addprefix $(CPPUTEST_OBJS_DIR)/,$(call __src_to,$1,$2))
src_to_o = $(call src_to,.o,$1)
src_to_d = $(call src_to,.d,$1)
src_to_gcda = $(call src_to,.gcda,$1)
src_to_gcno = $(call src_to,.gcno,$1)
time = $(shell date +%s)
delta_t = $(eval minus, $1, $2)
debug_print_list = $(foreach word,$1,echo "  $(word)";) echo;

#Derived
SRC = $(call get_src_from_dir_list, $(SRC_DIRS))
OBJ = $(call src_to_o,$(SRC))

STUFF_TO_CLEAN = $(OBJ)

ALL_SRC = $(SRC)

CPUFLAGS =--cpu=$(CPU)
ifeq ($(CPU_MODE), thumb)
  CPUFLAGS +=--apcs=/interwork
endif
DEPFLAGS =$(CPUFLAGS) -M $(INCLUDES) --depend_format=unix_escaped --depend_single_line --no_depend_system_headers
OPTFLAGS =-O1
CCFLAGS =$(CPUFLAGS) $(OPTFLAGS) -c $(INCLUDES)\
  --$(CPU_MODE)\
  --exceptions\
  -D__CLK_TCK=1000\


# If we're using VPATH
ifeq ($(CPPUTEST_USE_VPATH), Y)
# gather all the source directories and add them
	VPATH += $(sort $(dir $(ALL_SRC)))
# Add the component name to the objs dir path, to differentiate between same-name objects
	CPPUTEST_OBJS_DIR := $(addsuffix /$(COMPONENT_NAME),$(CPPUTEST_OBJS_DIR))
endif

INCLUDES_DIRS_EXPANDED = $(call get_dirs_from_dirspec, $(INCLUDE_DIRS))
INCLUDES += $(foreach dir, $(INCLUDES_DIRS_EXPANDED), -I$(dir))

DEP_FILES = $(call src_to_d, $(ALL_SRC))
STUFF_TO_CLEAN += $(DEP_FILES)


# Without the C library, we'll need to disable the C++ library and ... 
ifeq ($(CPPUTEST_USE_STD_C_LIB), N)
	CPPUTEST_USE_STD_CPP_LIB = N
	CPPUTEST_USE_MEM_LEAK_DETECTION = N
	CCFLAGS += -DCPPUTEST_STD_C_LIB_DISABLED
else
	INCLUDE_DIRS +=$(SYS_INCLUDE_DIRS)
endif

ifeq ($(CPPUTEST_USE_MEM_LEAK_DETECTION), N)
	CCFLAGS += -DCPPUTEST_MEM_LEAK_DETECTION_DISABLED
endif

ifeq ($(CPPUTEST_ENABLE_DEBUG), Y)
	CCFLAGS += -g
	ARFLAGS := --debug_symbols
endif

ifeq ($(CPPUTEST_USE_STD_CPP_LIB), N)
	CCFLAGS += -DCPPUTEST_STD_CPP_LIB_DISABLED
endif


OBJS_DIRS :=$(sort $(dir $(STUFF_TO_CLEAN)))

$(OBJS_DIRS) $(CPPUTEST_LIB_DIR):
	@echo Updating directory $@
	$(MKDIR) -p $@


#This is the rule for creating the dependency files
$(CPPUTEST_OBJS_DIR)/%.d: %.c Makefile | $(OBJS_DIRS)
	@echo Compiling C file $< for dependency. Out file $@.
	$(CC) $(DEPFLAGS) $< --depend=$@ --depend_target='$(patsubst %.d,%.o,$@)'

$(CPPUTEST_OBJS_DIR)/%.d: %.cpp Makefile | $(OBJS_DIRS)
	@echo Compiling C++ file $< for dependency. Out file $@.
	$(CC) $(DEPFLAGS) $< --depend=$@ --depend_target='$(patsubst %.d,%.o,$@)'

#This rule does the compilation C++ files
$(CPPUTEST_OBJS_DIR)/%.o: %.cpp $(CPPUTEST_OBJS_DIR)/%.d Makefile
	@echo Compiling C++ file $<. Out file $@
	$(CC) $(CCFLAGS) $< -o $@

#This rule does the compilation C files
$(CPPUTEST_OBJS_DIR)/%.o: %.c $(CPPUTEST_OBJS_DIR)/%.d Makefile
	@echo Compiling C file $<. Out file $@
	$(CC) $(CCFLAGS) $< -o $@


$(TARGET_LIB): $(OBJ) | $(CPPUTEST_LIB_DIR)
	@echo Archiving to $@
	$(AR) $(ARFLAGS) --create $@ $^


.PHONY: all

all: $(TARGET_LIB)
	@echo Done!


.PHONY: debug
debug:
	@echo
	@echo "Target Source files:"
	@$(call debug_print_list,$(SRC))
	@echo "Target Object files:"
	@$(call debug_print_list,$(OBJ))
	@echo "All Input Dependency files:"
	@$(call debug_print_list,$(DEP_FILES))
	@echo Stuff to clean:
	@$(call debug_print_list,$(STUFF_TO_CLEAN))
	@echo Includes:
	@$(call debug_print_list,$(INCLUDES))
	@echo Directories to create:
	@$(call debug_print_list,$(OBJS_DIRS))
	@echo Directories of CppUTest object files:
	@$(call debug_print_list,$(CPPUTEST_OBJS_DIR))
	@echo Flags:
	@$(call debug_print_list,$(CCFLAGS))


#Don't create dependencies when we're cleaning, for instance
ifeq (0, $(words $(findstring $(MAKECMDGOALS), $(NODEPS))))
    -include $(DEP_FILES)
endif

clean:
	@$(RM) -rf $(STUFF_TO_CLEAN)

=== src/CppUTestExt/CMakeLists.txt ===
set(CppUTestExt_src
        CodeMemoryReportFormatter.cpp
        MemoryReporterPlugin.cpp
        MockFailure.cpp
        MockSupportPlugin.cpp
        MockActualCall.cpp
        MockSupport_c.cpp
        MemoryReportAllocator.cpp
        MockExpectedCall.cpp
        MockNamedValue.cpp
        OrderedTest.cpp
        MemoryReportFormatter.cpp
        MockExpectedCallsList.cpp
        MockSupport.cpp
)

set(CppUTestExt_headers
        ${CppUTestRootDirectory}/include/CppUTestExt/CodeMemoryReportFormatter.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MemoryReportAllocator.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockExpectedCall.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockCheckedExpectedCall.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockExpectedCallsList.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockSupportPlugin.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MemoryReportFormatter.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockFailure.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockSupport.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockSupport_c.h
        ${CppUTestRootDirectory}/include/CppUTestExt/GMock.h
        ${CppUTestRootDirectory}/include/CppUTestExt/GTest.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MemoryReporterPlugin.h
        ${CppUTestRootDirectory}/include/CppUTestExt/OrderedTest.h
        ${CppUTestRootDirectory}/include/CppUTestExt/GTestConvertor.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockActualCall.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockCheckedActualCall.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockNamedValue.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockSupport.h
)

add_library(CppUTestExt STATIC ${CppUTestExt_src})
target_link_libraries(CppUTestExt ${CPPUNIT_EXTERNAL_LIBRARIES})
install(FILES ${CppUTestExt_headers} DESTINATION include/CppUTestExt)
install(TARGETS CppUTestExt
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)

=== tests/CppUTestExt/CMakeLists.txt ===
set(CppUTestExtTests_src
    AllTests.cpp
    CodeMemoryReportFormatterTest.cpp
    GMockTest.cpp
    GTest1Test.cpp
    MemoryReportAllocatorTest.cpp
    MemoryReporterPluginTest.cpp
    MemoryReportFormatterTest.cpp
    MockActualCallTest.cpp
    MockCheatSheetTest.cpp
    MockExpectedCallTest.cpp
    MockExpectedFunctionsListTest.cpp
    MockFailureTest.cpp
    MockPluginTest.cpp
    MockSupportTest.cpp
    MockSupport_cTestCFile.c
    MockSupport_cTest.cpp
    OrderedTestTest.cpp
)

if (MINGW)
    find_package (Threads REQUIRED)
    set(THREAD_LIB "pthread")
endif (MINGW)

add_executable(CppUTestExtTests ${CppUTestExtTests_src})
target_link_libraries(CppUTestExtTests CppUTest CppUTestExt ${THREAD_LIB} ${CPPUNIT_EXTERNAL_LIBRARIES})

if (TESTS)
    # get all test groups
    execute_process(COMMAND tests/CppUTestExt/CppUTestExtTests -lg OUTPUT_VARIABLE CppUTestTestsExt_Groups)
    # create separate test for each group
    separate_arguments(CppUTestTestsExt_Groups)
    foreach(group ${CppUTestTestsExt_Groups})
        message("TestGroup2: ${group}:")
        add_test(NAME CppUTestExt.${group} COMMAND ${EXECUTABLE_OUTPUT_PATH}/CppUTestExtTests -sg ${group} -c)
    endforeach()
endif (TESTS)

=== platforms_startup/armcc/AT91SAM7A3/Makefile ===
# Makefile to create startup library for AT91SAM7A3 chip

.SILENT:

CPU = ARM7TDMI
CPU_MODE = thumb
TARGET_PLATFORM =armcc_$(CPU)_$(CPU_MODE)

CPPUTEST_HOME = ../../..

# component name
COMPONENT_NAME = Startup_AT91SAM7A3

# directory to place artefacts
OBJS_DIR = objs

# directory to place startup library
LIB_DIR = $(CPPUTEST_HOME)/lib/$(TARGET_PLATFORM)

# directory with source files
SRC_DIRS = .

# directory with header files
INCLUDE_DIRS = .

# CYGWIN path
CYGWIN =C:/CYGWIN/bin
MKDIR  =$(CYGWIN)/mkdir
RM     =$(CYGWIN)/rm
TOUCH  =$(CYGWIN)/touch

KEIL_DIR=D:/Keil/ARM/ARMCC
CC=$(KEIL_DIR)/bin/armcc.exe
AS=$(KEIL_DIR)/bin/armasm.exe
AR=$(KEIL_DIR)/bin/armar.exe
# armcc system include path
SYS_INCLUDE_DIRS =$(KEIL_DIR)/include 

# adding Keil MDK-ARM system headers to build startup library
INCLUDE_DIRS +=$(SYS_INCLUDE_DIRS)

CPUFLAGS =--cpu=$(CPU)
ifeq ($(CPU_MODE), thumb)
  CPUFLAGS +=--apcs=/interwork
endif

DEPFLAGS =-M \
 $(INCLUDES) \
 --depend_format=unix_escaped \
 --depend_single_line \
 --no_depend_system_headers

OPTFLAGS =-O3

CPPUTEST_CPPFLAGS =$(CPUFLAGS) \
 $(OPTFLAGS) \
 -c \
 -g \
 $(INCLUDES) \
 --$(CPU_MODE) \
 -D__CLK_TCK=1000 \

ARFLAGS = --debug_symbols


TARGET_LIB = \
    $(LIB_DIR)/lib$(COMPONENT_NAME).a

#Helper Functions
get_src_from_dir  = $(wildcard $1/*.c) $(wildcard $1/*.asm)
get_src_from_dir_list = $(foreach dir, $1, $(call get_src_from_dir,$(dir)))
__src_to = $(subst .asm,$1, $(subst .c,$1,$2))
src_to = $(addprefix $3/,$(call __src_to,$1,$2))
src_to_o = $(call src_to,.o,$1,$2)
src_to_d = $(call src_to,.d,$1,$2)
time = $(shell date +%s)
delta_t = $(eval minus, $1, $2)
debug_print_list = $(foreach word,$1,echo "  $(word)";) echo

# for building CRT library
SRC = $(call get_src_from_dir_list, $(SRC_DIRS))
OBJ = $(call src_to_o,$(SRC),$(OBJS_DIR))
INCLUDES += $(foreach dir, $(INCLUDE_DIRS), -I$(dir))
DEP_FILES = $(call src_to_d, $(SRC), $(OBJS_DIR))
STUFF_TO_CLEAN = $(OBJ) $(DEP_FILES)

#Don't create CRT dependencies when we're cleaning, for instance
ifeq (0, $(words $(findstring $(MAKECMDGOALS), $(NODEPS))))
    -include $(DEP_FILES)
endif

all: $(TARGET_LIB)
	echo Done!

$(TARGET_LIB): $(OBJ) | $(LIB_DIR)
	$(AR) $(ARFLAGS) --create $@ $^
	echo Build CRT library done!

$(LIB_DIR) $(OBJS_DIR):
	echo Updating directory $@
	$(MKDIR) -p $@

#This is the rule for creating the dependency files
$(OBJS_DIR)/%.d: %.c Makefile | $(OBJS_DIR)
	echo Compiling C file $< for dependency. Out file $@.
	$(CC) $(DEPFLAGS) $< --depend=$@ --depend_target='$(patsubst %.d,%.o,$@)'

$(OBJS_DIR)/%.d: %.asm | $(OBJS_DIR)
	echo Compiling ASM file $< for dependency. Out file $@.
	$(TOUCH) $@

#This rule does the compilation C files
$(OBJS_DIR)/%.o: %.c $(OBJS_DIR)/%.d
	echo Compiling C file $<. Out file $@
	$(CC) $(CPPUTEST_CPPFLAGS) $< -o $@

#This rule does the compilation ASM
$(OBJS_DIR)/%.o: %.asm $(OBJS_DIR)/%.d
	echo Assembling file $<. Out file $@
	$(AS) $(CPUFLAGS) --diag-suppress 1786 $< -o $@


clean:
	@$(RM) -f $(STUFF_TO_CLEAN)

=== platforms_startup/armcc/LPC1768/Makefile ===
CPU := Cortex-M3
CPU_MODE := thumb
TARGET_PLATFORM :=armcc_$(CPU)_$(CPU_MODE)

CPPUTEST_HOME := ../../..

# имя компонента
COMPONENT_NAME := Startup_LPC1768

# промежуточный каталог, где производится компиляция startup-файлов
OBJS_DIR = objs

# каталог с библиотекой`
LIB_DIR := $(CPPUTEST_HOME)/lib/$(TARGET_PLATFORM)

# каталог с файлами приложения
SRC_DIRS := .

# каталог с заголовочными файлами
INCLUDE_DIRS := .

# CYGWIN path
CYGWIN :=C:/CYGWIN/bin
MKDIR  :=@$(CYGWIN)/mkdir
RM     :=@$(CYGWIN)/rm
TOUCH  :=@$(CYGWIN)/touch
ECHO   :=@$(CYGWIN)/echo

KEIL_DIR:=D:/Keil/ARM/ARMCC
CC:=@$(KEIL_DIR)/bin/armcc.exe
AS:=@$(KEIL_DIR)/bin/armasm.exe
AR:=@$(KEIL_DIR)/bin/armar.exe
# armcc system include path
SYS_INCLUDE_DIRS :=$(KEIL_DIR)/include 

# добавление системных заголовочных файлов для сборки CRT библиотеки
INCLUDE_DIRS +=$(SYS_INCLUDE_DIRS)

CPUFLAGS :=--cpu=$(CPU)
ifeq ($(CPU_MODE), thumb)
  CPUFLAGS +=--apcs=/interwork
endif
DEPFLAGS =-M $(INCLUDES) --depend_format=unix_escaped --depend_single_line --no_depend_system_headers
OPTFLAGS :=-O3
CPPUTEST_CPPFLAGS =$(CPUFLAGS) $(OPTFLAGS) -c -g $(INCLUDES) \
  --$(CPU_MODE) \
  -D__CLK_TCK=1000 \
  -D__UART0 \

ARFLAGS := --debug_symbols


TARGET_LIB := \
    $(LIB_DIR)/lib$(COMPONENT_NAME).a

#Helper Functions
get_src_from_dir  = $(wildcard $1/*.c) $(wildcard $1/*.asm)
get_src_from_dir_list = $(foreach dir, $1, $(call get_src_from_dir,$(dir)))
__src_to = $(subst .asm,$1, $(subst .c,$1,$2))
src_to = $(addprefix $3/,$(call __src_to,$1,$2))
src_to_o = $(call src_to,.o,$1,$2)
src_to_d = $(call src_to,.d,$1,$2)
time = $(shell date +%s)
delta_t = $(eval minus, $1, $2)
debug_print_list = $(foreach word,$1,$(ECHO) "  $(word)";) $(ECHO)

# for building CRT library
SRC := $(call get_src_from_dir_list, $(SRC_DIRS))
OBJ := $(call src_to_o,$(SRC),$(OBJS_DIR))
INCLUDES += $(foreach dir, $(INCLUDE_DIRS), -I$(dir))
DEP_FILES := $(call src_to_d, $(SRC), $(OBJS_DIR))
STUFF_TO_CLEAN := $(OBJ) $(DEP_FILES)

#Don't create CRT dependencies when we're cleaning, for instance
ifeq (0, $(words $(findstring $(MAKECMDGOALS), $(NODEPS))))
    -include $(DEP_FILES)
endif

$(TARGET_LIB): $(OBJ) | $(LIB_DIR)
	$(AR) $(ARFLAGS) --create $@ $^
	$(ECHO) Build CRT library done!

.PHONY: crt
crt:
	$(ECHO)
	$(ECHO) CRT =$(CRT)
	$(ECHO) SRC =$(SRC)
	$(ECHO) OBJ =$(OBJ)
	$(ECHO) INCLUDES =$(INCLUDES)
	$(ECHO) DEP_FILES =$(DEP_FILES)
	$(ECHO) STUFF_TO_CLEAN =$(STUFF_TO_CLEAN)
	$(ECHO) OBJS_DIR =$(OBJS_DIR)

$(LIB_DIR) $(OBJS_DIR):
	$(ECHO) Updating directory $@
	$(MKDIR) -p $@

#This is the rule for creating the dependency files
$(OBJS_DIR)/%.d: %.c Makefile | $(OBJS_DIR)
	$(ECHO) Compiling C file $< for dependency. Out file $@.
	$(CC) $(DEPFLAGS) $< --depend=$@ --depend_target='$(patsubst %.d,%.o,$@)'

$(OBJS_DIR)/%.d: %.asm | $(OBJS_DIR)
	$(ECHO) Compiling ASM file $< for dependency. Out file $@.
	$(TOUCH) $@

#This rule does the compilation C files
$(OBJS_DIR)/%.o: %.c $(OBJS_DIR)/%.d
	$(ECHO) Compiling C file $<. Out file $@
	$(CC) $(CPPUTEST_CPPFLAGS) $< -o $@

#This rule does the compilation ASM
$(OBJS_DIR)/%.o: %.asm $(OBJS_DIR)/%.d
	$(ECHO) Assembling file $<. Out file $@
	$(AS) $(CPUFLAGS) --diag-suppress 1786 $< -o $@


clean:
	@$(RM) -f $(STUFF_TO_CLEAN)


all: $(TARGET_LIB)
	$(ECHO) Done!

=== platforms_startup/armcc/LPC1833/Makefile ===
SHELL = cmd.exe

CPU := Cortex-M3
CPU_MODE := thumb
TARGET_PLATFORM :=armcc_$(CPU)_$(CPU_MODE)

CPPUTEST_HOME := ../../..

# имя компонента
COMPONENT_NAME := Startup_LPC1833

# промежуточный каталог, где производится компиляция startup-файлов
OBJS_DIR = objs

# каталог с библиотекой`
LIB_DIR := $(CPPUTEST_HOME)/lib/$(TARGET_PLATFORM)

# каталог с файлами приложения
SRC_DIRS := .

# каталог с заголовочными файлами
INCLUDE_DIRS := .

# CYGWIN path
CYGWIN :=C:/CYGWIN/bin
MKDIR  :=@$(CYGWIN)/mkdir
RM     :=@$(CYGWIN)/rm
TOUCH  :=@$(CYGWIN)/touch

KEIL_DIR:=D:/Keil/ARM/ARMCC
CC:=@$(KEIL_DIR)/bin/armcc.exe
AS:=@$(KEIL_DIR)/bin/armasm.exe
AR:=@$(KEIL_DIR)/bin/armar.exe
# armcc system include path
SYS_INCLUDE_DIRS :=$(KEIL_DIR)/include 

# добавление системных заголовочных файлов для сборки CRT библиотеки
INCLUDE_DIRS +=$(SYS_INCLUDE_DIRS)

CPUFLAGS :=--cpu=$(CPU) --apcs=/interwork
DEPFLAGS =-M $(INCLUDES) --depend_format=unix_escaped --depend_single_line --no_depend_system_headers
OPTFLAGS :=-O0
CCFLAGS =$(CPUFLAGS) \
 $(OPTFLAGS) \
 -c \
 --debug \
 $(INCLUDES) \
 --$(CPU_MODE) \
 --bss_threshold=0 \
 --strict_warnings \
 -D__CLK_TCK=1000 \
 -DCGU_IRC_FREQ=12000000 \

ARFLAGS := --debug_symbols


TARGET_LIB := \
    $(LIB_DIR)/lib$(COMPONENT_NAME).a

#Helper Functions
get_src_from_dir  = $(wildcard $1/*.c) $(wildcard $1/*.asm)
get_src_from_dir_list = $(foreach dir, $1, $(call get_src_from_dir,$(dir)))
__src_to = $(subst .asm,$1, $(subst .c,$1,$2))
src_to = $(addprefix $3/,$(call __src_to,$1,$2))
src_to_o = $(call src_to,.o,$1,$2)
src_to_d = $(call src_to,.d,$1,$2)
time = $(shell date +%s)
delta_t = $(eval minus, $1, $2)
debug_print_list = $(foreach word,$1,@echo "  $(word)";) @echo

# for building CRT library
SRC := $(call get_src_from_dir_list, $(SRC_DIRS))
OBJ := $(call src_to_o,$(SRC),$(OBJS_DIR))
INCLUDES += $(foreach dir, $(INCLUDE_DIRS), -I$(dir))
DEP_FILES := $(call src_to_d, $(SRC), $(OBJS_DIR))
STUFF_TO_CLEAN := $(OBJ) $(DEP_FILES)

#Don't create CRT dependencies when we're cleaning, for instance
ifeq (0, $(words $(findstring $(MAKECMDGOALS), $(NODEPS))))
    -include $(DEP_FILES)
endif

$(TARGET_LIB): $(OBJ) | $(LIB_DIR)
	$(AR) $(ARFLAGS) --create $@ $^
	@echo Build CRT library done!

.PHONY: crt
crt:
	@echo
	@echo CRT =$(CRT)
	@echo SRC =$(SRC)
	@echo OBJ =$(OBJ)
	@echo INCLUDES =$(INCLUDES)
	@echo DEP_FILES =$(DEP_FILES)
	@echo STUFF_TO_CLEAN =$(STUFF_TO_CLEAN)
	@echo OBJS_DIR =$(OBJS_DIR)

$(LIB_DIR) $(OBJS_DIR):
	@echo Updating directory $@
	$(MKDIR) -p $@

# Создание файлов зависимости для .c файлов
$(OBJS_DIR)/%.d: %.c | $(OBJS_DIR)
	@echo Compiling C file $< for dependency. Out file $@.
	$(CC) $(DEPFLAGS) --c99 $< --depend=$@ --depend_target='$(patsubst %.d,%.o,$@)'

# Создание файлов зависимости для .cpp файлов
$(OBJS_DIR)/%.d: %.cpp | $(OBJS_DIR)
	@echo Compiling C file $< for dependency. Out file $@.
	$(CC) $(DEPFLAGS) $< --depend=$@ --depend_target='$(patsubst %.d,%.o,$@)'

# Создание файлов зависимости для .asm файлов
$(OBJS_DIR)/%.d: %.asm | $(OBJS_DIR)
	@echo Compiling ASM file $< for dependency. Out file $@.
	$(TOUCH) $@



# Компиляция .asm файла
$(OBJS_DIR)/%.o: %.asm $(OBJS_DIR)/%.d
	@echo Assembling file $<. Out file $@
	$(AS) $(CPUFLAGS) --keep --debug --predefine "NO_CRP SETL {TRUE}" $< -o $@

# Компиляция .c файла
$(OBJS_DIR)/%.o: %.c $(OBJS_DIR)/%.d
	@echo Compiling C file $<. Out file $@
	$(CC) $(CCFLAGS) --c99 $< -o $@

# Компиляция .cpp файла
$(OBJS_DIR)/%.o: %.cpp $(OBJS_DIR)/%.d
	@echo Compiling C++ file $<. Out file $@
	$(CC) $(CCFLAGS) $< -o $@

clean:
	@$(RM) -f $(STUFF_TO_CLEAN)


all: $(TARGET_LIB)
	@echo Done!

=== debian/changelog ===
cpputest (3.7.2-1) unstable; urgency=medium

  * New upstream release that drops the test that fails on arm64, powerpc,
    ppc64el. Closes: #784674
  * Use "make tdd" to run the test suite as it is more verbose.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 11 May 2015 09:57:27 +0200

=== debian/control ===
Source: cpputest
Section: devel
Priority: optional
Maintainer: Raphaël Hertzog <hertzog@debian.org>
Homepage: http://cpputest.github.io/
Vcs-Git: git://anonscm.debian.org/collab-maint/cpputest.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/cpputest.git
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9.20120608~), dh-autoreconf

Package: cpputest
Architecture: all
Multi-Arch: foreign
Depends: libcpputest-dev, ${misc:Depends}
Suggests: ruby | ruby-interpreter
Description: C/C++ based unit test framework — main package
 CppUTest is a C/C++ based unit xUnit test framework for unit testing and
 for test-driving your code. It is written in C++ but is used in C and C++
 projects and frequently used in embedded systems.
 .
 CppUTest has a couple design principles:
  * Simple to use and small
  * Portable to old and new platforms
 .
 CppUTest also has support for building mocks and can be used by
 practitioners of Test Driven Development.
 .
 This is the main package. It contains some examples, support scripts
 and depends on libcpputest-dev which provides the test framework
 itself.

Package: libcpputest-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C/C++ based unit test framework — headers and static libraries
 CppUTest is a C/C++ based unit xUnit test framework for unit testing and
 for test-driving your code. It is written in C++ but is used in C and C++
 projects and frequently used in embedded systems.
 .
 CppUTest has a couple design principles:
  * Simple to use and small
  * Portable to old and new platforms
 .
 CppUTest also has support for building mocks and can be used by
 practitioners of Test Driven Development.
 .
 This is the package with the headers and the static libraries implementing
 the test framework.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules

override_dh_auto_test:
	$(MAKE) tdd

override_dh_compress:
	dh_compress -X.cpp

# Fixes for the cpputest (arch-all) package
override_dh_installexamples-indep:
	dh_installexamples
	chmod 644 debian/cpputest/usr/share/doc/cpputest/examples/*.dsw

override_dh_fixperms-indep:
	chmod 755 debian/cpputest/usr/share/cpputest/scripts/NewProject.sh \
		  debian/cpputest/usr/share/cpputest/scripts/convertToUnity/create_unity_test_runner.rb
	dh_fixperms

# Be explicit about "build" being a virtual target since it's a real directory
.PHONY: build

=== debian/watch ===
version=3
opts=downloadurlmangle=s/$/?raw=true/ \
https://github.com/cpputest/cpputest.github.io/tree/master/releases \
 .*/releases/[Cc]pp[Uu][Tt]est-v?(\d[\d.]*)\.tar\.gz

## cpputest 3.7.2+dfsg

=== debian/changelog ===
cpputest (3.7.2+dfsg-1) unstable; urgency=medium

  * Repackage upstream tarball to drop platforms* directories containing
    some non-free files. Closes: #823711
  * Update Standards-Version to 3.9.8.
  * Update Vcs-Git and Vcs-Browser to use https URLs.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 09 May 2016 22:15:27 +0200

=== debian/watch ===
version=3
opts=downloadurlmangle=s/$/?raw=true/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg// \
https://github.com/cpputest/cpputest.github.io/tree/master/releases \
 .*/releases/[Cc]pp[Uu][Tt]est-v?(\d[\d.]*)\.tar\.gz

## cpputest 3.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,34 @@
 project(CppUTest)
 
 set(CppUTest_version_major 3)
-set(CppUTest_version_minor 7.2)
+set(CppUTest_version_minor 8)
 
 # 2.6.3 is needed for ctest support
-cmake_minimum_required(VERSION 2.6.3)
+cmake_minimum_required(VERSION 2.8.7)
+
+# Check for functions before setting a lot of stuff
+include(CheckFunctionExists)
+set (CMAKE_REQUIRED_INCLUDES "unistd.h")
+check_function_exists(fork HAVE_FORK)
+if(HAVE_FORK)
+  add_definitions(-DCPPUTEST_HAVE_FORK)
+endif(HAVE_FORK)
+
+# Apply workaround for MinGW timespec redefinition (pthread.h / time.h)
+if (MINGW)
+    include(CheckStructHasMember)
+    check_struct_has_member("struct timespec" tv_sec time.h HAVE_STRUCT_TIMESPEC)
+    if (HAVE_STRUCT_TIMESPEC)
+        add_definitions(-D_TIMESPEC_DEFINED=1)
+    endif()
+endif()
 
 option(STD_C "Use the standard C library" ON)
 option(STD_CPP "Use the standard C++ library" ON)
 option(CPPUTEST_FLAGS "Use the CFLAGS/CXXFLAGS/LDFLAGS set by CppUTest" ON)
 option(MEMORY_LEAK_DETECTION "Enable memory leak detection" ON)
 option(EXTENSIONS "Use the CppUTest extenstion library" ON)
+option(LONGLONG "Support long long" OFF)
 option(MAP_FILE "Enable the creation of a map file" OFF)
 option(COVERAGE "Enable running with coverage" OFF)
 option(C++11 "Compile with C++11 support" OFF)
@@ -32,10 +50,13 @@
 
 include("${CppUTestRootDirectory}/cmake/Modules/CppUTestConfigurationOptions.cmake")
 include(CTest)
+#include("${CppUTestRootDirectory}/cmake/Modules/CheckFunctionExists.cmake")
+include("${CppUTestRootDirectory}/cmake/Modules/CppUTestBuildTimeDiscoverTests.cmake")
+include("${CppUTestRootDirectory}/cmake/Modules/CppUTestNormalizeTestOutputLocation.cmake")
 
 configure_file (
     "${PROJECT_SOURCE_DIR}/config.h.cmake"
-    "${PROJECT_BINARY_DIR}/config.h"
+    "${PROJECT_BINARY_DIR}/generated/CppUTestGeneratedConfig.h"
     )
 include_directories(${PROJECT_BINARY_DIR})
 add_definitions(-DHAVE_CONFIG_H)
@@ -51,19 +72,62 @@
     add_subdirectory(tests)
 endif (TESTS)
 
+set (INCLUDE_INSTALL_DIR "include")
+set (LIB_INSTALL_DIR "lib")
+set (INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/include")
+
 # Pkg-config file.
 set (prefix "${CMAKE_INSTALL_PREFIX}")
-set (exec_prefix "${CMAKE_INSTALL_PREFIX}")
-set (libdir "${LIB_INSTALL_DIR}")
-set (includedir "${INCLUDE_INSTALL_DIR}")
+set (exec_prefix "\${prefix}")
+set (libdir "\${exec_prefix}/${LIB_INSTALL_DIR}")
+set (includedir "\${prefix}/${INCLUDE_INSTALL_DIR}")
 set (PACKAGE_VERSION "${CppUTest_version_major}.${CppUTest_version_minor}")
 
 configure_file (cpputest.pc.in
-    ${CMAKE_CURRENT_SOURCE_DIR}/${CppUTest_PKGCONFIG_FILE} @ONLY)
+    ${CMAKE_CURRENT_BINARY_DIR}/${CppUTest_PKGCONFIG_FILE} @ONLY)
 
-install(FILES  ${CMAKE_CURRENT_SOURCE_DIR}/${CppUTest_PKGCONFIG_FILE}
+install(FILES  ${CMAKE_CURRENT_BINARY_DIR}/${CppUTest_PKGCONFIG_FILE}
     DESTINATION ${LIB_INSTALL_DIR}/pkgconfig
     )
+
+install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/generated/CppUTestGeneratedConfig.h"
+    DESTINATION "${INCLUDE_INSTALL_DIR}/CppUTest"
+    )
+
+# Try to include helper module
+include(CMakePackageConfigHelpers OPTIONAL
+  RESULT_VARIABLE PkgHelpers_AVAILABLE)
+# guard against older versions of cmake which do not provide it
+if(PkgHelpers_AVAILABLE)
+  configure_package_config_file(CppUTestConfig.cmake.install.in
+    ${CMAKE_CURRENT_BINARY_DIR}/install/CppUTestConfig.cmake
+    INSTALL_DESTINATION ${LIB_INSTALL_DIR}/CppUTest/cmake
+    PATH_VARS INCLUDE_INSTALL_DIR LIB_INSTALL_DIR)
+  write_basic_package_version_file(
+    ${CMAKE_CURRENT_BINARY_DIR}/install/CppUTestConfigVersion.cmake
+    VERSION ${CppUTest_version_major}.${CppUTest_version_minor}
+    COMPATIBILITY SameMajorVersion )
+  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/install/CppUTestConfig.cmake
+    ${CMAKE_CURRENT_BINARY_DIR}/install/CppUTestConfigVersion.cmake
+    DESTINATION ${LIB_INSTALL_DIR}/CppUTest/cmake )
+  install(EXPORT CppUTestTargets
+    DESTINATION ${LIB_INSTALL_DIR}/CppUTest/cmake)
+  configure_package_config_file(CppUTestConfig.cmake.build.in
+    ${CMAKE_CURRENT_BINARY_DIR}/CppUTestConfig.cmake
+    INSTALL_DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
+    PATH_VARS INCLUDE_DIR CMAKE_CURRENT_BINARY_DIR)
+  export(TARGETS CppUTest CppUTestExt
+    FILE "${CMAKE_CURRENT_BINARY_DIR}/CppUTestTargets.cmake")
+  write_basic_package_version_file(
+    ${CMAKE_CURRENT_BINARY_DIR}/CppUTestConfigVersion.cmake
+    VERSION ${CppUTest_version_major}.${CppUTest_version_minor}
+    COMPATIBILITY SameMajorVersion )
+  set(CppUTest_DIR "${CMAKE_CURRENT_BINARY_DIR}" CACHE PATH "The directory containing a CMake configuration file for CppUTest.")
+else()
+  message("If you wish to use find_package(CppUTest) in your own project to find CppUTest library"
+    " please update cmake to version which provides CMakePackageConfighelpers module"
+    " or write generators for CppUTestConfig.cmake by yourself.")
+endif()
 
 message("
 -------------------------------------------------------
@@ -76,9 +140,10 @@
     CppUTest CXXFLAGS:                  ${CPPUTEST_CXX_FLAGS}
     CppUTest LDFLAGS:                   ${CPPUTEST_LD_FLAGS}
 
-Features configure in CppUTest:
+Features configured in CppUTest:
     Memory Leak Detection:              ${MEMORY_LEAK_DETECTION}
     Compiling Extensions:               ${EXTENSIONS}
+    Support Long Long:                  ${LONGLONG}
     Use CppUTest flags:                 ${CPPUTEST_FLAGS}
 
     Using Standard C library:           ${STD_C}
@@ -88,5 +153,8 @@
     Generating map file:                ${MAP_FILE}
     Compiling with coverage:            ${COVERAGE}
 
+    Compile and run self-tests          ${TESTS}
+    Run self-tests separately           ${TESTS_DETAILED}
+
 -------------------------------------------------------
 ")

=== tests/CMakeLists.txt ===
enable_testing()

set(CppUTestTests_src
    AllTests.cpp
    SetPluginTest.cpp
    CheatSheetTest.cpp
    SimpleStringTest.cpp
    CommandLineArgumentsTest.cpp
    TestFailureTest.cpp
    TestFailureNaNTest.cpp
    CommandLineTestRunnerTest.cpp
    TestFilterTest.cpp
    TestHarness_cTest.cpp
    JUnitOutputTest.cpp
    TestHarness_cTestCFile.c
    MemoryLeakDetectorTest.cpp
    TestInstallerTest.cpp
    AllocLetTestFree.c
    MemoryOperatorOverloadTest.cpp
    TestMemoryAllocatorTest.cpp
    MemoryLeakWarningTest.cpp
    TestOutputTest.cpp
    AllocLetTestFreeTest.cpp
    TestRegistryTest.cpp
    AllocationInCFile.c
    PluginTest.cpp
    TestResultTest.cpp
    PreprocessorTest.cpp
    TestUTestMacro.cpp
    TestUTestStringMacro.cpp
    AllocationInCppFile.cpp
    UtestTest.cpp
    SimpleMutexTest.cpp
    UtestPlatformTest.cpp
    TeamCityOutputTest.cpp
)

if (MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4723")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4723")
endif (MSVC)

if (MINGW)
    find_package (Threads REQUIRED)
    set(THREAD_LIB "pthread")
endif (MINGW)

if (${CMAKE_HOST_SYSTEM_NAME} MATCHES "OpenBSD")
   set (THREADS_HAVE_PTHREAD_ARG 1)
   find_package (Threads REQUIRED)
   set (THREAD_LIB "pthread")
endif ()

add_executable(CppUTestTests ${CppUTestTests_src})
cpputest_normalize_test_output_location(CppUTestTests)
target_link_libraries(CppUTestTests CppUTest ${THREAD_LIB})

add_subdirectory(CppUTestExt)
cpputest_buildtime_discover_tests(CppUTestTests)

=== platforms/Dos/Makefile ===
CXX := wcl
CC  := wcl
AR := wlib
LINK := wlink
LOG := ALLTESTS.LOG
NULL :=
space := $(NULL) #
comma := ,
path_separator := /
drive = $(subst $(CYGDRIVE),$(lastword $(subst /, ,$(CYGDRIVE))):/,$(1))
convert_paths = $(if $(CYGDRIVE),$(subst /,$(path_separator),$(call drive,$(1))),$(1))

-include ../platforms/Dos/platform.mk
include ../platforms/Dos/sources.mk

# Disable W013 unreachable code - it overreacts to CHECK_EQUAL macros
# Disable W367 conditional expression in if statement is always true - same
# Disable W368 conditional expression in if statement is always false - same
# Disable W391 assignment found in boolean expression - we don't care

CFLAGS := \
  -q -c -os -oc -d0 -we -w=3 -wcd=13 -wcd=367 -wcd=368 -wcd391 -wcd=472 -ml -zm \
  -dCPPUTEST_MEM_LEAK_DETECTION_DISABLED=1 -dCPPUTEST_STD_CPP_LIB_DISABLED=1 \
  -i$(call convert_paths,$(CPPUTEST_HOME)/include) \
  -i$(call convert_paths,$(CPPUTEST_HOME)/include/Platforms/Dos) \
  -i$(call convert_paths,$(WATCOM)/h) -i$(call convert_paths,$(WATCOM)/h/nt) \

CXXFLAGS := $(CFLAGS) -xds

.PHONY: all clean

all: CPPU.LIB CPPUX.LIB CPPU1.EXE CPPU2.EXE CPPU3.EXE CPPU4.EXE \
    CPPU5.EXE CPPU6.EXE CPPU7.EXE

clean:
	rm -rf ../src/CppUTest/*.o ../src/CppUTestExt/*.o \
    ../src/Platforms/dos/*.o ../tests/*.o ../tests/CppUTestExt/*.o \
    *.o *.map *.txt *.LOG *.EXE *.err *.LIB *.LST

%.o: %.cpp
	$(CXX) $(CXXFLAGS) -fo=$(call convert_paths,$@) $(call convert_paths,$<)

%.o: %.c
	$(CC) $(CFLAGS) -fo=$(call convert_paths,$@) $(call convert_paths,$<)

.SECONDEXPANSION:

%.LIB: $$($$*_OBJECTS)
	$(AR) -q -lCPPU.LST $@ $(addprefix +,$(call convert_paths,$?))

%.EXE: $$($$*_OBJECTS) | CPPU.LIB CPPUX.LIB
	$(LINK) opt q,map,st=50k sys dos lib CPPU.LIB,CPPUX.LIB \
    file $(subst $(space),$(comma),$(call convert_paths,$?)) name $@

=== src/CppUTestExt/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 set(CppUTestExt_src
         CodeMemoryReportFormatter.cpp
+        IEEE754ExceptionsPlugin.cpp
         MemoryReporterPlugin.cpp
         MockFailure.cpp
         MockSupportPlugin.cpp
@@ -16,6 +17,7 @@
 
 set(CppUTestExt_headers
         ${CppUTestRootDirectory}/include/CppUTestExt/CodeMemoryReportFormatter.h
+        ${CppUTestRootDirectory}/include/CppUTestExt/IEEE754ExceptionsPlugin.h
         ${CppUTestRootDirectory}/include/CppUTestExt/MemoryReportAllocator.h
         ${CppUTestRootDirectory}/include/CppUTestExt/MockExpectedCall.h
         ${CppUTestRootDirectory}/include/CppUTestExt/MockCheckedExpectedCall.h
@@ -36,10 +38,11 @@
         ${CppUTestRootDirectory}/include/CppUTestExt/MockSupport.h
 )
 
-add_library(CppUTestExt STATIC ${CppUTestExt_src})
+add_library(CppUTestExt STATIC ${CppUTestExt_src} ${CppUTestExt_headers})
 target_link_libraries(CppUTestExt ${CPPUNIT_EXTERNAL_LIBRARIES})
 install(FILES ${CppUTestExt_headers} DESTINATION include/CppUTestExt)
 install(TARGETS CppUTestExt
+    EXPORT CppUTestTargets
     RUNTIME DESTINATION bin
     LIBRARY DESTINATION lib
     ARCHIVE DESTINATION lib)

=== tests/CppUTestExt/CMakeLists.txt ===
set(CppUTestExtTests_src
    AllTests.cpp
    CodeMemoryReporterTest.cpp
    GMockTest.cpp
    GTest1Test.cpp
    IEEE754PluginTest.cpp
    IEEE754PluginTest_c.c
    MemoryReportAllocatorTest.cpp
    MemoryReporterPluginTest.cpp
    MemoryReportFormatterTest.cpp
    MockActualCallTest.cpp
    MockCheatSheetTest.cpp
    MockCallTest.cpp
    MockComparatorCopierTest.cpp
    MockExpectedCallTest.cpp
    ExpectedFunctionsListTest.cpp
    MockFailureReporterForTest.cpp
    MockFailureTest.cpp
    MockHierarchyTest.cpp
    MockNamedValueTest.cpp
    MockParameterTest.cpp
    MockPluginTest.cpp
    MockSupportTest.cpp
    MockSupport_cTestCFile.c
    MockSupport_cTest.cpp
    MockStrictOrderTest.cpp
    MockReturnValueTest.cpp
    OrderedTestTest.cpp
)

if (MINGW)
    find_package (Threads REQUIRED)
    set(THREAD_LIB "pthread")
endif (MINGW)

add_executable(CppUTestExtTests ${CppUTestExtTests_src})
cpputest_normalize_test_output_location(CppUTestExtTests)
target_link_libraries(CppUTestExtTests CppUTest CppUTestExt ${THREAD_LIB} ${CPPUNIT_EXTERNAL_LIBRARIES})
cpputest_buildtime_discover_tests(CppUTestExtTests)

=== debian/changelog ===
cpputest (3.8-7) unstable; urgency=medium

  * Update Vcs-* fields in light of move to salsa.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 05 Feb 2018 20:37:15 +0100

cpputest (3.8-6) unstable; urgency=medium

  * Add explicit "build" target in debian/rules due to the existence of a
    "build" directory in the upstream files. Closes: #888598
  * Switch to debhelper 11.
  * Bump Standards-Version to 4.1.3.
  * Do not run test suite if DEB_BUILD_OPTIONS contains nocheck.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 05 Feb 2018 18:56:17 +0100

cpputest (3.8-5) unstable; urgency=medium

  * No longer build the static library with -fPIC. -fPIE is enabled by
    default at the gcc level and it's enough. Closes: #842105

 -- Raphaël Hertzog <hertzog@debian.org>  Wed, 02 Nov 2016 18:44:24 +0100

cpputest (3.8-4) unstable; urgency=medium

  * Build static libraries with -fPIC so that executables linked against
    CppUTest can be built with -fPIE. Closes: #837363

 -- Raphaël Hertzog <hertzog@debian.org>  Wed, 14 Sep 2016 11:13:00 +0200

cpputest (3.8-3) unstable; urgency=medium

  * Add new patch to fix builds on armel, m68k, s390x, ppc64 and sparc64.

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 17 Jun 2016 23:34:37 +0200

cpputest (3.8-2) unstable; urgency=medium

  * Properly install files generated by make install. Closes: #827279
  * Add a patch to install include/CppUTestExt/CodeMemoryReportFormatter.h
  * Add DEP-8 test suite to ensure that the package works fine.

 -- Raphaël Hertzog <hertzog@debian.org>  Wed, 15 Jun 2016 14:17:11 +0200

cpputest (3.8-1) unstable; urgency=medium

  * New upstream release.
  * No longer repack upstream tarball as problematic files have been dropped
    upstream.
  * Update watch file to track new location in main github repository.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 13 Jun 2016 23:00:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Raphaël Hertzog <hertzog@debian.org>
 Homepage: http://cpputest.github.io/
-Vcs-Git: git://anonscm.debian.org/collab-maint/cpputest.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/cpputest.git
-Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 9.20120608~), dh-autoreconf
+Vcs-Git: https://salsa.debian.org/debian/cpputest.git
+Vcs-Browser: https://salsa.debian.org/debian/cpputest
+Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 11)
 
 Package: cpputest
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# The build target must not be empty because it's also a real directory
# (see #888598).
.PHONY: build
build:
	dh $@

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) tdd
endif

override_dh_compress:
	dh_compress -X.cpp

override_dh_missing:
	dh_missing --fail-missing

# Fixes for the cpputest (arch-all) package
override_dh_installexamples-indep:
	dh_installexamples
	chmod 644 debian/cpputest/usr/share/doc/cpputest/examples/*.dsw

override_dh_fixperms-indep:
	chmod 755 debian/cpputest/usr/share/cpputest/scripts/NewProject.sh \
		  debian/cpputest/usr/share/cpputest/scripts/convertToUnity/create_unity_test_runner.rb
	dh_fixperms

=== debian/tests/control ===
Tests: build-and-run-upstream-testsuite
Restrictions: allow-stderr
Depends: libcpputest-dev, g++, pkg-config
